--- old/usr/src/uts/common/inet/sctp/sctp_conn.c	2014-07-28 07:44:30.502218212 -0400
+++ new/usr/src/uts/common/inet/sctp/sctp_conn.c	2014-07-28 07:44:30.508166226 -0400
@@ -168,9 +168,9 @@
 	if (slc != NULL) {
 		int64_t now;
 
-		if (atomic_add_32_nv(&slc->slc_cnt, 1) > slc->slc_max + 1) {
+		if (atomic_inc_32_nv(&slc->slc_cnt) > slc->slc_max + 1) {
 			now = ddi_get_lbolt64();
-			atomic_add_32(&slc->slc_cnt, -1);
+			atomic_dec_32(&slc->slc_cnt);
 			SCTP_KSTAT(sctps, sctp_listen_cnt_drop);
 			slc->slc_drop++;
 			if (now - slc->slc_report_time >
@@ -189,7 +189,7 @@
 
 	if ((eager = sctp_create_eager(sctp)) == NULL) {
 		if (slc_set)
-			atomic_add_32(&slc->slc_cnt, -1);
+			atomic_dec_32(&slc->slc_cnt);
 		return (NULL);
 	}
 	econnp = eager->sctp_connp;
